Project Chrono: chrono::vehicle::ChPitmanArm Class Reference

Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
chrono::vehicle::ChPitmanArm Class Referenceabstract
VEHICLE module » Wheeled vehicles » Steering subsystem

## Description

Base class for a Pitman Arm steering subsystem.

The steering subsystem is modeled with respect to a right-handed frame with with X pointing towards the front, Y to the left, and Z up (ISO standard).

When attached to a chassis, both an offset and a rotation (as a quaternion) are provided.

`#include <ChPitmanArm.h>`

Inheritance diagram for chrono::vehicle::ChPitmanArm:
[legend]
Collaboration diagram for chrono::vehicle::ChPitmanArm:
[legend]

## Public Member Functions
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, const ChVector3d &location, const ChQuaternion<> &rotation) override
| Initialize this steering subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the steering subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the steering subsystem.
virtual void | Synchronize (double time, const DriverInputs &driver_inputs) override
| Update the state of this steering subsystem at the current time.
virtual void | LogConstraintViolations () override
| Log current constraint violations.
Public Member Functions inherited from chrono::vehicle::ChSteering
const ChFrame & | GetRelTransform () const
| Get the frame of the steering subsystem relative to the associated chassis reference frame.
std::shared_ptr< ChBody > | GetSteeringLink () const
| Get a handle to the main link of the steering subsystems.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Protected Types
enum | PointId { STEERINGLINK , PITMANARM , REV , UNIV , REVSPH_R , REVSPH_S , TIEROD_PA , TIEROD_IA , NUM_POINTS }
| Identifiers for the various hardpoints. More...
enum | DirectionId { REV_AXIS , UNIV_AXIS_ARM , UNIV_AXIS_LINK , REVSPH_AXIS , NUM_DIRS }
| Identifiers for the various direction unit vectors. More...

## Protected Member Functions
| ChPitmanArm (const std::string &name, bool vehicle_frame_inertia=false)
| Protected constructor.
void | SetVehicleFrameInertiaFlag (bool val)
| Indicate whether or not inertia matrices are specified with respect to a vehicle-aligned centroidal frame (flag=true) or with respect to the body centroidal frame (flag=false).
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual const ChVector3d | getLocation (PointId which)=0
| Return the location of the specified hardpoint.
virtual const ChVector3d | getDirection (DirectionId which)=0
| Return the unit vector for the specified direction.
virtual double | getSteeringLinkMass () const =0
| Return the mass of the steering link body.
virtual double | getPitmanArmMass () const =0
| Return the mass of the Pitman arm body.
virtual const ChVector3d & | getSteeringLinkInertiaMoments () const =0
| Return the moments of inertia of the steering link body.
virtual const ChVector3d & | getSteeringLinkInertiaProducts () const =0
| Return the products of inertia of the steering link body.
virtual const ChVector3d & | getPitmanArmInertiaMoments () const =0
| Return the moments of inertia of the Pitman arm body.
virtual const ChVector3d & | getPitmanArmInertiaProducts () const =0
| Return the products of inertia of the Pitman arm body.
virtual double | getSteeringLinkRadius () const =0
| Return the radius of the steering link body (visualization only).
virtual double | getPitmanArmRadius () const =0
| Return the radius of the Pitman arm body (visualization only).
virtual double | getMaxAngle () const =0
| Return the maximum rotation angle of the revolute joint.
Protected Member Functions inherited from chrono::vehicle::ChSteering
| ChSteering (const std::string &name)
| Construct a steering subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
std::shared_ptr< ChBody > | m_arm
| handle to the Pitman arm body
std::shared_ptr< ChLinkMotorRotationAngle > | m_revolute
| handle to the chassis-arm revolute joint
std::shared_ptr< ChLinkRevoluteSpherical > | m_revsph
| handle to the revolute-spherical joint (idler arm)
std::shared_ptr< ChLinkUniversal > | m_universal
| handle to the arm-link universal joint
Protected Attributes inherited from chrono::vehicle::ChSteering
ChFrame | m_rel_xform
| location and orientation relative to associated chassis
std::shared_ptr< ChBody > | m_link
| handle to the main steering link
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Enumeration Documentation

## ◆ DirectionId

enum chrono::vehicle::ChPitmanArm::DirectionId
| protected

Identifiers for the various direction unit vectors.

Enumerator
REV_AXIS | revolute joint
UNIV_AXIS_ARM | universal joint (Pitman arm side)
UNIV_AXIS_LINK | universal joint (steering link side)
REVSPH_AXIS | revolute joint for idler arm

## ◆ PointId

enum chrono::vehicle::ChPitmanArm::PointId
| protected

Identifiers for the various hardpoints.

Enumerator
STEERINGLINK | steering link location (com)
PITMANARM | Pitman arm location (com).
REV | location of joint between Pitman arm and chassis
UNIV | location of joint between Pitman arm and steering link
REVSPH_R | location of revolute joint for the idler arm
REVSPH_S | location of spherical joint for the idler arm
TIEROD_PA | tierod connection point (Pitman arm side)
TIEROD_IA | tierod connection point (idler arm side)

## Constructor & Destructor Documentation

## ◆ ChPitmanArm()

chrono::vehicle::ChPitmanArm::ChPitmanArm | ( | const std::string & | name,
|  | bool | vehicle_frame_inertia = false )
| protected

Protected constructor.

Parameters

  [in] | name | name of the subsystem
  [in] | vehicle_frame_inertia | inertia specified in vehicle-aligned centroidal frames?

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChPitmanArm::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| overridevirtual

Add visualization assets for the steering subsystem.

This default implementation uses primitives.

Reimplemented from chrono::vehicle::ChPart.

## ◆ getDirection()

virtual const ChVector3d chrono::vehicle::ChPitmanArm::getDirection | ( | DirectionId | which | ) |
| protectedpure virtual

Return the unit vector for the specified direction.

The returned vector must be expressed in the suspension reference frame.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getLocation()

virtual const ChVector3d chrono::vehicle::ChPitmanArm::getLocation | ( | PointId | which | ) |
| protectedpure virtual

Return the location of the specified hardpoint.

The returned location must be expressed in the suspension reference frame.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getMaxAngle()

virtual double chrono::vehicle::ChPitmanArm::getMaxAngle | ( |  | ) | const
| protectedpure virtual

Return the maximum rotation angle of the revolute joint.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getPitmanArmInertiaMoments()

virtual const ChVector3d & chrono::vehicle::ChPitmanArm::getPitmanArmInertiaMoments | ( |  | ) | const
| protectedpure virtual

Return the moments of inertia of the Pitman arm body.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getPitmanArmInertiaProducts()

virtual const ChVector3d & chrono::vehicle::ChPitmanArm::getPitmanArmInertiaProducts | ( |  | ) | const
| protectedpure virtual

Return the products of inertia of the Pitman arm body.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getPitmanArmMass()

virtual double chrono::vehicle::ChPitmanArm::getPitmanArmMass | ( |  | ) | const
| protectedpure virtual

Return the mass of the Pitman arm body.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getPitmanArmRadius()

virtual double chrono::vehicle::ChPitmanArm::getPitmanArmRadius | ( |  | ) | const
| protectedpure virtual

Return the radius of the Pitman arm body (visualization only).

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getSteeringLinkInertiaMoments()

virtual const ChVector3d & chrono::vehicle::ChPitmanArm::getSteeringLinkInertiaMoments | ( |  | ) | const
| protectedpure virtual

Return the moments of inertia of the steering link body.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getSteeringLinkInertiaProducts()

virtual const ChVector3d & chrono::vehicle::ChPitmanArm::getSteeringLinkInertiaProducts | ( |  | ) | const
| protectedpure virtual

Return the products of inertia of the steering link body.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getSteeringLinkMass()

virtual double chrono::vehicle::ChPitmanArm::getSteeringLinkMass | ( |  | ) | const
| protectedpure virtual

Return the mass of the steering link body.

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ getSteeringLinkRadius()

virtual double chrono::vehicle::ChPitmanArm::getSteeringLinkRadius | ( |  | ) | const
| protectedpure virtual

Return the radius of the steering link body (visualization only).

Implemented in chrono::vehicle::artcar::ARTcar_PitmanArm, chrono::vehicle::feda::FEDA_PitmanArm, chrono::vehicle::generic::Generic_PitmanArm, chrono::vehicle::hmmwv::HMMWV_PitmanArm, chrono::vehicle::mrole::mrole_PitmanArm, and chrono::vehicle::PitmanArm.

## ◆ GetTemplateName()

virtual std::string chrono::vehicle::ChPitmanArm::GetTemplateName | ( |  | ) | const
| inlineoverridevirtual

Get the name of the vehicle subsystem template.

Implements chrono::vehicle::ChPart.

## ◆ Initialize()

void chrono::vehicle::ChPitmanArm::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | const ChVector3d & | location,
|  | const ChQuaternion<> & | rotation )
| overridevirtual

Initialize this steering subsystem.

The steering subsystem is initialized by attaching it to the specified chassis at the specified location (with respect to and expressed in the reference frame of the chassis) and with specified orientation (with respect to the chassis reference frame).

Parameters

  [in] | chassis | associated chassis subsystem
  [in] | location | location relative to the chassis frame
  [in] | rotation | orientation relative to the chassis frame

Reimplemented from chrono::vehicle::ChSteering.

## ◆ InitializeInertiaProperties()

void chrono::vehicle::ChPitmanArm::InitializeInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Initialize subsystem inertia properties.

Derived classes must override this function and set the subsystem mass (m_mass) and, if constant, the subsystem COM frame and its inertia tensor. This function is called during initialization of the vehicle system.

Implements chrono::vehicle::ChPart.

## ◆ LogConstraintViolations()

void chrono::vehicle::ChPitmanArm::LogConstraintViolations | ( |  | ) |
| overridevirtual

Log current constraint violations.

Reimplemented from chrono::vehicle::ChSteering.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChPitmanArm::RemoveVisualizationAssets | ( |  | ) |
| overridevirtual

Remove visualization assets for the steering subsystem.

Reimplemented from chrono::vehicle::ChPart.

## ◆ SetVehicleFrameInertiaFlag()

void chrono::vehicle::ChPitmanArm::SetVehicleFrameInertiaFlag | ( | bool | val | ) |
| inlineprotected

Indicate whether or not inertia matrices are specified with respect to a vehicle-aligned centroidal frame (flag=true) or with respect to the body centroidal frame (flag=false).

Note that this function must be called before Initialize().

## ◆ Synchronize()

void chrono::vehicle::ChPitmanArm::Synchronize | ( | double | time,
|  | const DriverInputs & | driver_inputs )
| overridevirtual

Update the state of this steering subsystem at the current time.

The steering subsystem is provided the current steering driver input (a value between -1 and +1). Positive steering input indicates steering to the left. This function is called during the vehicle update.

Parameters

  [in] | time | current time
  [in] | driver_inputs | current driver inputs

Implements chrono::vehicle::ChSteering.

## ◆ UpdateInertiaProperties()

void chrono::vehicle::ChPitmanArm::UpdateInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Update subsystem inertia properties.

Derived classes must override this function and set the global subsystem transform (m_xform) and, unless constant, the subsystem COM frame (m_com) and its inertia tensor (m_inertia). Calculate the current inertia properties and global frame of this subsystem. This function is called every time the state of the vehicle system is advanced in time.

Implements chrono::vehicle::ChPart.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/steering/ChPitmanArm.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/steering/ChPitmanArm.cpp